#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <errno.h>  
#include <time.h>    

#include "termin.h"

void extendReminderList();
int add2RemindeList (Reminder *r);
int calcDateBackward (int datum, int tim, int offset , int offset2, int unit);
int calcDateForward (int datum, int tim, int offset , int offset2, int unit);
int sendReminder (Reminder *r);
int sendreminder2User(Reminder *r,int id);
int sendreminder2Group(Reminder *r,int id);
int sendReminderByEmail(Reminder *r,int uid);
int sendReminderByDialog(Reminder *r,int uid);
int sendReminderBySignal(Reminder *r,int uid);
int compareReminder(Reminder *r1, Reminder *r2);
int compReminder(const void * p1,const void *p2);
int recalcRepeatReminder(Date *d,Reminder *r);
int str2Reminder(Reminder *r,char *t,int startDate, int startTime ,int reminder4Date);
char *reminder2Str(Reminder *r,char *t,int reminder4Str);
int ignoreReminder(int did,int uid);
char * formatMail(char *mask,char *text,Reminder *r,int ext);
void readReminderTemplate(FILE *fp,char *txt);

FILE *fprl;

void initReminderList()
{
 int i;
 char file[1024];
 FILE *fp;
 reminderList.list = new ( Reminder *) [DATEBLOCKSIZE];
 reminderList.anz =0;
 reminderList.max =DATEBLOCKSIZE;
 reminderList.blocks =1;
 for(i=0;i<DATEBLOCKSIZE; i++)
  reminderList.list[i]=NULL;
 sprintf(file,"%s/reminder.log",dataDir);
 fprl=fopen(file,"w");

 sprintf(file,"%s/templates/EinladungExtern.text",dataDir);
 fp = fopen (file,"r");
 if (fp ==NULL)
  mailMaskEinlExternText="Einladung\n\n%E von %A %l zu folgendem Termin ein:\n\n\t%T\n\nBeginn: %B\nEnde  : %S\nOrt   : %s\n\n\nweitere Informationen\n\n%D\n\n--\nDies ist eine automatische generierte Einladung der %M bei \n\t%A\n";
 else
  readReminderTemplate(fp,mailMaskEinlExternText);
 sprintf(file,"%s/templates/EinladungExtern.subject",dataDir);
 fp = fopen (file,"r");
 if (fp ==NULL)
  mailMaskEinlExternSubj="Einladung von %A";
 else
  readReminderTemplate(fp,mailMaskEinlInternSubj);

 sprintf(file,"%s/templates/EinladungIntern.text",dataDir);
 fp = fopen (file,"r");
 if (fp ==NULL)
  mailMaskEinlInternText="Einladung\n\n%E %l zu folgendem Termin ein:\n\n\t%T\n\nBeginn: %B\nEnde  : %S\nOrt   : %sRn\n\nweitere Informationen\n\n%D\n\nDer Termin wurden von %I eingetragen.\n\n--\nDies ist eine automatische generierte Einladung der %M bei \n\t%A\n";
 else
  readReminderTemplate(fp,mailMaskEinlInternText);
 sprintf(file,"%s/templates/EinladungIntern.subject",dataDir);
 fp = fopen (file,"r");
 if (fp ==NULL)
  mailMaskEinlInternSubj="Einladung von %A";
 else
  readReminderTemplate(fp,mailMaskEinlInternSubj);

 sprintf(file,"%s/templates/ErinnerungExtern.text",dataDir);
 fp = fopen (file,"r");
 if (fp ==NULL)
  mailMaskErinExternText="Erinnerung\n\nFolgender Termin wurde von %E bei %A angesetzt:\n\n\t%T\n\nBeginn: %B\nEnde  : %S\nOrt   : %R\n\n\nweitere Infromationen\n\n%D\n\n\n--\nDies ist eine automatische Erinnerung der %M bei \n\t%A\n";
 else
  readReminderTemplate(fp,mailMaskErinExternText);
 sprintf(file,"%s/templates/ErinnerungExtern.subject",dataDir);
 fp = fopen (file,"r");
 if (fp ==NULL)
  mailMaskErinExternSubj="Terminerinnerung: %T";
 else
  readReminderTemplate(fp,mailMaskErinInternSubj);

 sprintf(file,"%s/templates/ErinnerungIntern.text",dataDir);
 fp = fopen (file,"r");
 if (fp ==NULL)
  mailMaskErinInternText="Erinnerung\n\nFolgender Termin wurde von %E angesetzt:\n\n\t%T\n\nBeginn: %B\nEnde  : %S\nOrt   : %R\n\n\nweitere Infromationen\n\n%D\n\n\n--\nDies ist eine automatische Erinnerung der %M bei \n\t%A\n";
 else
  readReminderTemplate(fp,mailMaskErinInternText);
 sprintf(file,"%s/templates/ErinnerungIntern.subject",dataDir);
 fp = fopen (file,"r");
 if (fp ==NULL)
  mailMaskErinInternSubj="Terminerinnerung: %T";
 else
  readReminderTemplate(fp,mailMaskErinInternSubj);

 sprintf(file,"%s/templates/ErinnerungToDO.text",dataDir);
 fp = fopen (file,"r");
 if (fp ==NULL)
  mailMaskErinToDoText="Erinnerung\n\nDie Aufgabe \n\n\t %T\n\nsoll bis %B fertiggestellt sein.\n\n\nWeitere Informationen\nInitiator:       %I\nAufgabendetails: %D\n\n\n--\nDies ist eine automatische Erinnerung der %M bei \n\t%A\n";
 else
  readReminderTemplate(fp,mailMaskErinToDoText);
 sprintf(file,"%s/templates/ErinnerungToDO.subject",dataDir);
 fp = fopen (file,"r");
 if (fp ==NULL)
  mailMaskErinToDoSubj="Erinnerung: Aufgabe '%T' fertigstellen";
 else
  readReminderTemplate(fp,mailMaskErinToDoSubj);

 sprintf(file,"%s/templates/MahnungToDO.text",dataDir);
 fp = fopen (file,"r");
 if (fp ==NULL)
  mailMaskMahnToDoText="MAHNUNG\n\nDie Fertigstellung der Aufgabe \n\n\t %T\n\nist berfllig\nDer Zeiltermin war %S\n\n\nWeitere Informationen\nInitiator:       %I\nAufgabendetails: %D\n\n\n--\nDies ist eine automatische Mahnung der %M bei \n\t%A\n";
 else
  readReminderTemplate(fp,mailMaskMahnToDoText);
 sprintf(file,"%s/templates/MahnungToDO.subject",dataDir);
 fp = fopen (file,"r");
 if (fp ==NULL)
  mailMaskMahnToDoSubj="Mahnung: Aufgabe '%s' ist versptet";
 else
  readReminderTemplate(fp,mailMaskMahnToDoSubj);

}
void readReminderTemplate(FILE *fp,char *txt)
{
 int fd;
 struct stat  stat;

 fd = fileno(fp);
 fstat(fd,& stat);
 if(txt !=NULL)
  {
   delete txt;
   txt=NULL;
  }
 txt = new char [ stat.st_size +16];
 fread(txt,sizeof(char), stat.st_size+1,fp);
 txt[ stat.st_size]='\0';
 fclose(fp);
}
void clearReminderList ()
{
 delete reminderList.list;
}

void extendReminderList()
{
 Reminder **tmp;
 int anz,anz0;
 int i;
 
 reminderList.blocks++;
 anz= dateBlocks * DATEBLOCKSIZE;
 tmp= new ( Reminder *) [anz];
 reminderList.max=anz;
 anz0= anz - DATEBLOCKSIZE;

 memcpy(tmp,reminderList.list,anz0*sizeof(Reminder *));
 delete reminderList.list;
 reminderList.list=tmp;
 for(i=anz0;i<anz; i++)
  reminderList.list[i]=NULL;
}

char *reminder2Str4Todo(Reminder *r,char *t)
{
 return(reminder2Str(r,t,false));
}
char *reminder2Str4Date(Reminder *r,char *t)
{
 return(reminder2Str(r,t,true));
}
char *reminder2Str(Reminder *r,char *t,int reminder4Str)
{
 char *us,*tp,name[32],full[128],typ;
 float off;

 us="?";
 tp="?";
 switch (r->unit)
  {
  case 'm' :
   us = "Minuten";
   off= r->offset;
   break;
  case 'h' :
   us = "Stunden";
   off= r->offset + r->offset2/60.;
   break;
  case 'd' :
   us="Tage";
   off= r->offset + r->offset2/24.;
   break;
  }
 switch( (r->typ & REMINDER_DEST_MASK) )
  {
  case REMINDER_BY_EMAIL:
   tp="E-mail";
   break;
  case REMINDER_BY_DIALOG:
   tp="Fenster";
   break;
  case REMINDER_BY_SIGNAL:
   tp="Signal";
   break;
  }
 if(r->id<GROUPOFFSET)
  {
   strcpy(name,userList[r->id].name);
   strcpy(full,userList[r->id].full);
  } 
 else if (r->id<ROOMOFFSET)
  {
   strcpy(name,groupList[r->id-GROUPOFFSET].name);
   sprintf(full,"Gruppe %s",groupList[r->id-GROUPOFFSET].name);
  } 
 else if (r->id>=ADDRESOFFSET && r->id <= MAX_ID)
  {
   int idx;
   aid2cname(r->id-ADDRESOFFSET,full);
   strcpy(name,full);
  } 
 else if(r->id == REMIND_ALL_USER)
  {
   strcpy(name,"alle");
   sprintf(full,"Alle");
  }
 else if(r->id == REMIND_ALL_INTERN)
  {
   strcpy(name,"intern");
   sprintf(full,"interne Teilnehmer");
  }
 else if(r->id == REMIND_ALL_EXTERN)
  {
   strcpy(name,"extern");
   sprintf(full,"externe Teilnehmer");
  }

 switch (r->typ & REMINDER_TYPE_MASK)
  {
  case REMINDER_EINLADUNG:  typ='E'; break;
  case REMINDER_ERINNERUNG: typ='R'; break;
  case REMINDER_MAHNUNG:    typ='M'; break;
  default:                  typ='R'; break;
  }
 sprintf(t,"{%5.2f %s %s %s {%s} %c} ",off,us,tp,name,full,typ);
 return(t);
}


int addReminder2Date ( Date *d, Reminder *r)
{
 if((r->typ & REMINDER_MAHNUNG)>0)
  r->ct.ctrl->tim = calcDateForward(d->startDate,d->startTime,r->offset,r->offset2,r->unit);
 else
  r->ct.ctrl->tim = calcDateBackward(d->startDate,d->startTime,r->offset,r->offset2,r->unit);
 if((r->ct.ctrl->tim - time(NULL)) > -60 )
  r->status = REMINDER_WAITING;
 else 
  r->status = REMINDER_DONE;
 memcpy(&d->reminder[d->remAnz],r,sizeof(Reminder));
 d->remAnz++;
 add2RemindeList(r);
 return(true);
}

int addReminder2Date ( Date *d, char *t)
{
 Reminder *r;

 if( strlen(trimRight(t))==0)
  return(true);

 r= & d->reminder[d->remAnz];
 if(!str2Reminder(r,t,d))
  return(false);
 d->remAnz++;
 add2RemindeList(r);
 return(true);
}
int addReminder2Date ( TodoItem *todo, Reminder *r)
{
 if((r->typ & REMINDER_MAHNUNG)>0)
  r->ct.ctrl->tim = calcDateForward(todo->startDate,1800,r->offset,r->offset2,r->unit);
 else
  r->ct.ctrl->tim = calcDateBackward(todo->startDate,1800,r->offset,r->offset2,r->unit);
 if((r->ct.ctrl->tim - time(NULL)) > -60 )
  r->status = REMINDER_WAITING;
 else 
  r->status = REMINDER_DONE;
 memcpy(&todo->reminder[todo->remAnz],r,sizeof(Reminder));
 todo->remAnz++;
 add2RemindeList(r);
 return(true);
}
int addReminder2Todo ( TodoItem *todo, char *t)
{
 Reminder *r;

 if( strlen(trimRight(t))==0)
  return(true);

 r= & todo->reminder[todo->remAnz];
 if(!str2Reminder(r,t,todo))
  return(false);
 todo->remAnz++;
 add2RemindeList(r);
 return(true);
}
int str2Reminder(Reminder *r,char *t,TodoItem *todo)
{
 if(!str2Reminder(r,t,todo->startDate,1000,false))
  return(false);
 r->date = (void *) todo;
 return(true);
}
int str2Reminder(Reminder *r,char *t,Date *d)
{
 if(!str2Reminder(r,t,d->startDate,d->startTime,true))
  return(false);
 printf("got reminder for Date %s : (%d/%d) - %d;%d %c",d->descr,d->startDate,d->startTime,r->offset,r->offset2,r->unit);
 r->date = (void *) d;
 return(true);
}
int str2Reminder(Reminder *r,char *t,int startDate, int startTime ,int reminder4Date)
{
 char *tp[8];
 float offset;
 int id;

 split(t,tp,8);

 if(r->ct.ctrl== NULL)
  r->ct.ctrl = new ReminderControl ;


 r->typ =0;
 if( strstr(tp[2],"E-mail") != NULL)
  r->typ |= REMINDER_BY_EMAIL;
 if( strstr(tp[2],"Fenster") != NULL)
  r->typ |= REMINDER_BY_DIALOG;
 if( strstr(tp[2],"Signal") != NULL)
  r->typ |= REMINDER_BY_SIGNAL;

 if(!reminder4Date)
  r->typ != REMINDER_FOR_TODO;

 if(tp[5][0] == 'E')
  r->typ |= REMINDER_EINLADUNG;
 if(tp[5][0] == 'R')
  r->typ |= REMINDER_ERINNERUNG;
 if(tp[5][0] == 'M')
  r->typ |= REMINDER_MAHNUNG;

 if(r->typ ==0)
  printf("REMINDER: strange Typ %d / %s\n",r->typ,tp[2]);

 offset = atof(tp[0]);
 if(strcmp(tp[1],"Tage")==0)
  {
   r->unit     = 'd';
   r->offset   = (int)floor(offset);
   r->offset2  = (int)floor((offset- r->offset)*24);
  }
 else if(strcmp(tp[1],"Stunden")==0)
  {
   r->unit     = 'h';
   r->offset   = (int)floor(offset);
   r->offset2  = (int)floor((offset- r->offset)*60);
  }
 else 
  {
   r->unit     = 'm';
   r->offset   = (int)floor(offset);
   r->offset2  = 0;
  }
 if((r->typ & REMINDER_MAHNUNG)>0)
  r->ct.ctrl->tim = calcDateForward(startDate,startTime,r->offset,r->offset2,r->unit);
 else
  r->ct.ctrl->tim = calcDateBackward(startDate,startTime,r->offset,r->offset2,r->unit);
 if((r->ct.ctrl->tim - time(NULL)) > -60 )
  {
   if(r->ct.ctrl->tim != r->ct.ctrl->lastSendTim)
    r->status = REMINDER_WAITING;
   else
    r->status = REMINDER_DONE;
  }
 else 
  r->status = REMINDER_DONE;
 

 
 if(strcmp(tp[3],"alle")==0)
  id =REMIND_ALL_USER;
 else if (strcmp(tp[3],"intern")==0)
  id =REMIND_ALL_INTERN;
 else if (strcmp(tp[3],"extern")==0)
  id =REMIND_ALL_EXTERN;
 else
  {
   id=uname2uid(tp[3]);
   if(id<0)
    {
     id = gname2gid(tp[3]);
     if(id>=0)
      id += GROUPOFFSET;
     if(id<0)
      {
       id= aname2aid(tp[3]);
       if(id>=0)
	id+= ADDRESOFFSET;
      }
    }
  }

 if(id<0)
  return(false);
 r->id=id;
 return(true);
}

int recalcReminder(Date *d)
{
 int i;
 Reminder *r;


 for(i=0;i< d->remAnz; i++)
  {
   r = & d->reminder[i];

    if(r->ct.ctrl ==NULL)
     r->ct.ctrl = new ReminderControl;

    if((r->typ & REMINDER_MAHNUNG)>0)
     r->ct.ctrl->tim = calcDateForward(d->startDate,d->startTime,r->offset,r->offset2,r->unit);
    else
     r->ct.ctrl->tim = calcDateBackward(d->startDate,d->startTime,r->offset,r->offset2,r->unit);

   // FIXME dateShift
   r->ct.ctrl->startDate = d->startDate;
   r->ct.ctrl->startTime = d->startTime;
   r->ct.ctrl->stopDate  = d->stopDate;
   r->ct.ctrl->stopTime  = d->stopTime;
  }
 return(true);
}

int resetReminderStates(Date *d)
{
 int i;
 for(i=0;i< d->remAnz; i++)
  d->reminder[i].status = REMINDER_WAITING;
}
int recalcRepeatReminder(Date *d,Reminder *r)
{
 int i,rtim;
 CalendarItem ci;


 if(r->ct.ctrl ==NULL)
  {
   r->ct.ctrl = new ReminderControl;
   r->ct.ctrl->tim =0;
  }

 rtim = r->ct.ctrl->tim;
 nextDateAfterNow(&ci,d);
 r->ct.ctrl->startDate = ci.startDate;
 r->ct.ctrl->startTime = ci.startTime;
 r->ct.ctrl->stopDate  = ci.stopDate;
 r->ct.ctrl->stopTime  = ci.stopTime;
 if((r->typ & REMINDER_MAHNUNG)>0)
  r->ct.ctrl->tim = calcDateForward(ci.startDate,ci.startTime,r->offset,r->offset2,r->unit);
 else
  r->ct.ctrl->tim = calcDateBackward(ci.startDate,ci.startTime,r->offset,r->offset2,r->unit);
 if(r->ct.ctrl->tim > r->ct.ctrl->lastSendTim)
  r->status = REMINDER_WAITING;

 return(true);
}


int reminderIsInList(Reminder *r, Reminder *list, int anz)
{
 int i;
 int identical;
 for(i=0;i<anz; i++)
  {
   if(compareReminder(r,&list[i]))
    return (true);
  }
 return(false);
}

int compareReminder(Reminder *r1, Reminder *r2)
{
 if(r1->id      != r2->id     )
  return(false);
 if(r1->offset  != r2->offset )
  return(false);
 if(r1->offset2 != r2->offset2)
  return(false);
 if(r1->unit    != r2->unit   )
  return(false);
 if(r1->typ     != r2->typ    )
  return(false);

 return (true);
}

int recreateReminderList()
{
 int i,r,ctim;
 int offset;

 ctim   = time(NULL) ;
 ctim  -= (ctim %60);

 //FIXME  Recreate f[r TODO-Reminder fehlt

 if(verbose)
  printf("REbuilding reminderList\n");
 reminderList.anz =0;
 for (i=0;i<dateAnz;i++)
  if(dateList[i] !=NULL)
   if(!dateList[i]->deleted)
    {
     if(verbose)
      if(dateList[i]->remAnz>0)
       printf("found %d reminder in date %d/%s\n",dateList[i]->remAnz,i,dateList[i]->descr);
     for(r=0;r<dateList[i]->remAnz; r++)
      {
       switch(dateList[i]->reminder[r].unit)
	{
	case 'm': offset =      1800+30; break;
	case 'h': offset =      3600+30; break;
	case 'd': offset =    4*3600+30; break;
	default:  offset = 30; break;
	}
       if(dateList[i]->repeatTyp != NO_REPEAT)
	recalcRepeatReminder(dateList[i],&dateList[i]->reminder[r]);
       if( dateList[i]->reminder[r].ct.ctrl->tim - ctim > -offset)
	{
	 if(verbose)
	  printf("\t checking %d: %d; rem on %10d/%s;\n\t\t\tnow:   %10d/%s\n",r,dateList[i]->reminder[r].status,
		dateList[i]->reminder[r].ct.ctrl->tim,strTrim(ctime((const time_t*)&dateList[i]->reminder[r].ct.ctrl->tim)),
		ctim,strTrim(ctime((const time_t*)&ctim)));
	 if(verbose)
	  printf("\t\t     lastSend: %10d/%s\n",dateList[i]->reminder[r].ct.ctrl->lastSendTim,strTrim(ctime((const time_t*)&dateList[i]->reminder[r].ct.ctrl->lastSendTim)));
	 if(dateList[i]->reminder[r].status == REMINDER_WAITING || dateList[i]->repeatTyp != NO_REPEAT)
	  {
	   if(verbose)
	    printf("\t\t adding reminder %d on position %d\n",r,reminderList.anz);
	   add2RemindeList(&dateList[i]->reminder[r]);
	   dateList[i]->reminder[r].date = dateList[i];
	  }
	}
      }
    }

 updateReminderList();
 nextReminder =0;
 lastReminderListCreation =time(NULL);
 for(r=nextReminder; r<reminderList.anz; r++)
  if(reminderList.list[r]->status == REMINDER_WAITING)
   {
    nextReminder=r;
    break;
   }
}
int add2RemindeList (Reminder *r)
{
 reminderList.list[reminderList.anz] =r;
 reminderList.anz ++;
 if(reminderList.anz > reminderList.max)
  extendReminderList();
}
int updateReminderList ()
{
 // FIXME sort RemindeList
 qsort(reminderList.list,reminderList.anz,sizeof(Reminder *),compReminder);
}

int compReminder(const void * p1,const void *p2)
{
 int t1,t2;
 Reminder *r1;

 t1 = (*((Reminder **)p1))->ct.ctrl->tim;
 t2 = (*((Reminder **)p2))->ct.ctrl->tim;
 return(t1-t2);
}

char *date2Str(int datum, int tim,char *t)
{
 int day,mon,year,hour,min;
 
 year = datum /10000;
 mon  = (datum%10000) /100;
 day  = datum %100;
 hour = tim /100;
 min  = tim %100;
 
 sprintf(t,"%2d.%2d.%4d, %2d:%02d Uhr",day,mon,year,hour,min);
 return(t);
}
char *date2Str(int datum, char *t)
{
 int day,mon,year,hour,min;
 
 year = datum /10000;
 mon  = (datum%10000) /100;
 day  = datum %100;
 
 sprintf(t,"%2d.%2d.%4d",day,mon,year);
 return(t);
}

int weekDayByDate(int datum)
{
 struct tm tm,*tmp;
 int tim;

 tm.tm_mday = datum %100;
 tm.tm_mon  = (datum%10000)/100 -1;
 tm.tm_year = datum /10000-1900;
 tm.tm_hour = 12;
 tm.tm_min  =tm.tm_sec =0;
 tmp=&tm;
 tim = mktime(&tm);
 tmp =localtime((const time_t *)&tim);
 return((tmp->tm_wday+6) %7);
}

int calcDate (int *datum, int *tim, int offset, int offset2 , int unit)
{
 int day,mon,year,hour,min;
 int monLen[13]={0,31,28,31,30,31,30,31,31,30,31,30,31},feb;
 struct tm tms;

 // printf("shift %d, %d  by %d/%d %c to \t",*datum,*tim,offset,offset2,unit);

 year = *datum /10000;
 mon  = (*datum%10000) /100;
 day  = *datum %100;
 hour = *tim /100;
 min  = *tim %100;
 
 switch (unit)
  {
  case 'm': 
   min  += offset; 
   break;
  case 'h': 
   hour += offset;
   min  += offset2;
   break;
  case 'd':
   day  += offset;
   hour += offset2;
   break;
  case 'w' :
   day  += offset*7 + offset2;
   break;
  case 'M' :
   mon  += offset;
   day  += offset2;
   break;
  case 'y' :
   year += offset;
   mon  += offset2;
   break;

  default:
   return(false);
  }


 while(min < 0)
  {
   min+=60;
   hour  --;
  }
 while(min>60)
  {
   min-=60;
   hour++;
  }
 while(hour<0)
  {
   hour += 24;
   day --;
  }
 while(hour >=24)
  {
   hour -=24;
   day++;
  }
 while(day<0)
  {
   mon--;
   if(mon<0)
    {
     mon=12;
     year--;
    }
   day += monLen[mon];
   if(mon ==2)
    if( (year %4) == 0)
     day ++;
  }

 if(mon==2 && (year %4)==0)
  feb=1;
 else
  feb=0;

 while(day>monLen[mon]+feb)
  {
   day -= (monLen[mon]+feb);
   mon++;
   if(mon==2 && (year %4)==0)
    feb=1;
   else
    feb=0;
   
   if(mon>12)
    {
     year++;
     mon=1;
    }
  }

 *datum = year*10000+mon*100+day;
 *tim   = 100*hour+min;
 return(true);
}

int getWeekDayInMonth(int *weekCount, int *wday,int datum)
{
 struct tm tms,*tmp;
 int tim,day;

 tms.tm_sec =  0;
 tms.tm_min =  0;
 tms.tm_hour= 12;
 tms.tm_mday= day = datum %100;
 tms.tm_mon = (datum%10000) /100 -1;
 tms.tm_year= datum /10000-1900;

 tim = mktime(&tms);
 tmp = localtime((const time_t*) &tim);
 
 *wday = (tmp->tm_wday+6)%7;
 *weekCount = (int)floor( (day-0.5)/7.);
}

int getCountedWeekDayDatum(int weekCount, int wday, int datum)
{
 struct tm tms,*tmp;
 int dw,w1day,day,tim;

 tms.tm_sec =  0;
 tms.tm_min =  0;
 tms.tm_hour= 12;
 tms.tm_mday= 1;
 tms.tm_mon = (datum%10000) /100 -1;
 tms.tm_year= datum /10000-1900;
 tim = mktime(&tms);
 tmp = localtime((const time_t*) &tim);

 w1day = (tmp->tm_wday+6) % 7;
 dw    = (wday -w1day +7) % 7;
 day   = dw + weekCount*7 + 1;   // Die 1 , da der Refere4bnz tag der 1. des Monats ist
 datum = datum -datum %100 + day;
 return(datum);
}

int calcDateBackward (int datum, int tim, int offset , int offset2, int unit)
{
 int day,mon,year,hour,min;
 int monLen[13]={0,31,28,31,30,31,30,31,31,30,31,30,31};
 struct tm tms;

 year = datum /10000;
 mon  = (datum%10000) /100;
 day  = datum %100;
 hour = tim /100;
 min  = tim %100;

 switch (unit)
  {
  case 'm': 
   min  -= offset; 
   break;
  case 'h': 
   hour -= offset;
   min  -= offset2;
   break;
  case 'd':
   day  -= offset;
   hour -= offset2;
   break;
  default:
   return(0);
  }

 while(min < 0)
  {
   min+=60;
   hour  --;
  }
 while(hour<0)
  {
   hour += 24;
   day --;
  }
 while(day<0)
  {
   mon--;
   if(mon<0)
    {
     mon=12;
     year--;
    }
   day += monLen[mon];
   if(mon ==2)
    if( (year %4) == 0)
     day ++;
  }

 tms.tm_sec =  0;
 tms.tm_min =min;
 tms.tm_hour=hour;
 tms.tm_mday=day;
 tms.tm_mon =mon-1;
 tms.tm_year=year-1900;

 
 return(mktime(&tms));
}
int calcDateForward (int datum, int tim, int offset , int offset2, int unit)
{
 int day,mon,year,hour,min;
 int monLen[13]={0,31,28,31,30,31,30,31,31,30,31,30,31};
 struct tm tms;

 year = datum /10000;
 mon  = (datum%10000) /100;
 day  = datum %100;
 hour = tim /100;
 min  = tim %100;

 switch (unit)
  {
  case 'm': 
   min  += offset; 
   break;
  case 'h': 
   hour += offset;
   min  += offset2;
   break;
  case 'd':
   day  += offset;
   hour += offset2;
   break;
  default:
   return(0);
  }

 while(min >60)
  {
   min-=60;
   hour++;
  }
 while(hour>23)
  {
   hour -= 24;
   day ++;
  }
 while(day>monLen[mon])
  {
   day -= monLen[mon];
   if(mon ==2)
    if( (year %4) == 0)
     day --;
   mon++;
   if(mon>12)
    {
     mon=1;
     year++;
    }
  }

 tms.tm_sec =  0;
 tms.tm_min =min;
 tms.tm_hour=hour;
 tms.tm_mday=day;
 tms.tm_mon =mon-1;
 tms.tm_year=year-1900;

 
 return(mktime(&tms));
}

int check4Reminder()
{
 int r,ctim;

 ctim   = time(NULL) ;
 ctim  -= (ctim %60);

 //FIXME only for debugging:
 nextReminder=0;

 if(verbose)
  printf("Checking Reminders (%d .. %d)\n",nextReminder,reminderList.anz);
 for(r=nextReminder; r<reminderList.anz; r++)
  {
   
   Date *d;
   d = (Date * ) reminderList.list[r]->date;
   if(verbose)
    printf("\tReminder %3d for date %d/'%s' : stat=%d, via=%d\n\t\t\ttim    = %d =\t%s\t\t\tcurTime= %d, delta =%d\n",
	   r,d->id,d->descr,reminderList.list[r]->status,reminderList.list[r]->typ,
	   reminderList.list[r]->ct.ctrl->tim,ctime((time_t*)&reminderList.list[r]->ct.ctrl->tim),ctim,
	   ctim-reminderList.list[r]->ct.ctrl->tim);
   if(verbose)
    printf("\t\t\tlastSend= %d, %s\n",reminderList.list[r]->ct.ctrl->lastSendTim,ctime((time_t*)&reminderList.list[r]->ct.ctrl->lastSendTim));
   if(reminderList.list[r]->status == REMINDER_WAITING)
    {
     if(reminderList.list[r]->ct.ctrl->tim-ctim <30)
      {
       sendReminder(reminderList.list[r]);
      }
    }
  }
 for(r=nextReminder; r<reminderList.anz; r++)
  if(reminderList.list[r]->status == REMINDER_WAITING)
   {
    nextReminder=r;
    break;
   }
}

int sendReminder (Reminder *r)
{
 int i,ret;
 Date *d;
 int *m2u,j;

 d= (Date * ) r->date;
 if(fprl!=NULL)
  {
   time_t tim;
   tim=time(NULL);
   fprintf(fprl,"%s: Sending reminder on date  %d\'%s'\n",strChop(ctime(&tim)),d->id,d->descr);
  }

 if(r->id==REMIND_ALL_USER || r->id==REMIND_ALL_INTERN || r->id==REMIND_ALL_EXTERN)
  {
   m2u = new int [userAnz];
   for(i=0;i<userAnz; i++)
    m2u[i]=0;

   for(i=0;i<d->partAnz;i++)
    {
     if(r->id!=REMIND_ALL_EXTERN)  // mail geht an intern oder alle
      {
       if(d->part[i].id<GROUPOFFSET)
	m2u[d->part[i].id] = 1;
       else if(d->part[i].id<ROOMOFFSET)
	for(j=0;j<groupList[d->part[i].id-GROUPOFFSET].anz; j++)
	 m2u[ groupList[d->part[i].id-GROUPOFFSET].membr[j]] =1;
      } 
     if(r->id!=REMIND_ALL_INTERN) //mail an extern oder alle
      {
       if(d->part[i].id>=ADDRESOFFSET && d->part[i].id<=MAX_ID)
	sendreminder2User(r,d->part[i].id);
      }
    }
   for(i=0;i<userAnz; i++)
    if(m2u[i]==1)
     sendreminder2User(r,i);
  }
 else if(r->id<GROUPOFFSET || (r->id >=ADDRESOFFSET && r->id<=MAX_ID))  
  sendreminder2User(r,r->id);
 else
  sendreminder2Group(r,r->id-GROUPOFFSET);
 
 r->ct.ctrl->lastSendTim=r->ct.ctrl->tim;
 r->status=REMINDER_DONE;
 return(true);
}

int sendreminder2User(Reminder *r,int id)
{
 int ret;
 if( (r->typ & REMINDER_BY_EMAIL) >0)
  ret=sendReminderByEmail(r,id);
 else  if( (r->typ & REMINDER_BY_DIALOG) >0)
  ret=sendReminderByDialog(r,id);
 else  if( (r->typ & REMINDER_BY_SIGNAL) >0)
  ret=sendReminderBySignal(r,id);
 return(ret);
}
int sendreminder2Group(Reminder *r,int id)
{
 int ret,i,uid;
 for(i=0; i<groupList[id].anz; i++)
  {
   uid = groupList[id].membr[i];
   if( (r->typ & REMINDER_BY_EMAIL) >0)
    ret = sendReminderByEmail(r,uid);
   else  if( (r->typ & REMINDER_BY_DIALOG) >0)
    ret = sendReminderByDialog(r,uid);
   else  if( (r->typ & REMINDER_BY_SIGNAL) >0)
    ret = sendReminderBySignal(r,uid);
  }
 return(ret);
}

int sendReminderByEmail(Reminder *r,int uid)
{
 char cmd[17000],text[16384],mail[128],smtp[128],subj[512];
 char debugInfo[8192],rt[256];
 char start[64],stop[64];
 Date *d;
 TodoItem *todo;
 int i,me,me2,j;
 int send2Extern=false;

 if(noReminder)
  return(true);

 d= (Date * ) r->date;
 todo= (TodoItem * ) r->date;
#ifdef V038
 if( (r->typ & REMINDER_FOR_TODO) >0)
  if(ignoreReminder(d->id, uid))
   {
    if(verbose)
     printf("Skip Reminder on Date %d/%s for User %d/%s\n",d->id,d->descr,uid,userList[uid].name);
    return(true);
   }
#endif

 for(i=0;i<4; i++)
  {
   if(uid>=ADDRESOFFSET && uid<=MAX_ID)
    {
     int idx;
     if(i>0)
      continue;
     idx = aid2idx(uid-ADDRESOFFSET);
     if(idx<0)
      continue;
     strcpy(mail,adrList[idx]->mail);
     strcpy(smtp,""); // FIXE ggfs festen SMTP fr externe einfhren
     send2Extern=true;
    }
   else
    {
     strcpy(mail,userList[uid].mail[i]);
     strcpy(smtp,userList[uid].smtp[i]);
    }

   if(mail[0] == '\0')
    continue;

   int etyp = r->typ & REMINDER_TYPE_MASK;
   printf("sending Reminder Typ %X/%X (EINLADUNG=%X, Erinnerung=%X, Mahnung=%X) mail=%s smtp=%s\n",
	  r->typ & REMINDER_TYPE_MASK,etyp,
	  REMINDER_EINLADUNG,REMINDER_ERINNERUNG,REMINDER_MAHNUNG,mail,smtp);
   switch (etyp)
    {
    case REMINDER_EINLADUNG: 
     {
      char *lstr,eList[4096],txt[128];
      int eanz;
      sprintf(eList,"%s",userList[d->init.id].full);
      eanz=1;
      for(j=0;j<d->partAnz; j++)
       if(d->part[j].typ=='E')
	{
	 if(d->part[j].id<GROUPOFFSET)
	  sprintf(txt,", %s",userList[d->part[j].id].full);
	 else if(d->part[j].id<ROOMOFFSET && !send2Extern)
	  sprintf(txt,", Gruppe %s",groupList[d->part[j].id-GROUPOFFSET].name);
	 strcat(eList,txt);
	 eanz++;
	}
      if(eanz >1)
       lstr="laden";
      else
       lstr="ld";
      if (send2Extern)
       {
	formatMail(mailMaskEinlExternSubj,subj,r,send2Extern);
	formatMail(mailMaskEinlExternText,text,r,send2Extern);
// 	sprintf(subj,"Einladung von %s",company);
// 	formatMail("Einladung\n\n%E von %A %l zu folgendem Termin ein:\n\n\t%T\n\nBeginn: %B\nEnde  : %S\nOrt   : %s\n\n\nweitere Informationen\n\n%D\n\n--\nDies ist eine automatische generierte Einladung der %M bei \n\t%A\n",text,r,send2Extern);
// 	sprintf(text,"Einladung\n\n%s von der Firma %s %s zu folgendem Termin ein:\n\n\t%s\n\nBeginn: %s\nEnde  : %s\nOrt   : %s\n\n\nweitere Details\n\n%s\n\n--\nDies ist eine automatische generierte Einladung der %s bei \n\t%s\n",
// 		eList,company,lstr,d->descr,
// 		date2Str(r->ct.ctrl->startDate,r->ct.ctrl->startTime,start),date2Str(r->ct.ctrl->stopDate,r->ct.ctrl->stopTime,stop),
// 		roomList[d->room].name,d->descr+d->tlen,progName,company);
       }
      else
       {
	formatMail(mailMaskEinlInternSubj,subj,r,send2Extern);
	formatMail(mailMaskEinlInternText,text,r,send2Extern);
// 	sprintf(subj,"Einladung: %s",d->descr);
// 	formatMail("Einladung\n\n%E %l zu folgendem Termin ein:\n\n\t%T\n\nBeginn: %B\nEnde  : %S\nOrt   : %sRn\n\nweitere Informationen\n\n%D\n\nDer Termin wurden von %I eingetragen.\n\n--\nDies ist eine automatische generierte Einladung der %M bei \n\t%A\n",text,r,send2Extern);
	//	sprintf(text,"Einladung\n\n%s %s zu folgendem Termin ein:\n\n\t%s\n\nBeginn: %s\nEnde  : %s\nOrt   : %s\n\n\nweitere Details\n\n%s\n\nDer Termin wurden von %s eingetragen.\n\n--\nDies ist eine automatische generierte Einladung der %s bei \n\t%s\n",
// 		eList,lstr,d->descr,
// 		date2Str(r->ct.ctrl->startDate,r->ct.ctrl->startTime,start),date2Str(r->ct.ctrl->stopDate,r->ct.ctrl->stopTime,stop),
// 		roomList[d->room].name,d->descr+d->tlen,userList[todo->init].full,progName,company);
       }
     }
     break;
    case REMINDER_ERINNERUNG: 
     {
      if( (r->typ & REMINDER_FOR_TODO) >0)
       {
	formatMail(mailMaskErinToDoSubj,subj,r,0);
	formatMail(mailMaskErinToDoText,text,r,0);
//         sprintf(subj,"Erinnerung: Aufgabe '%s' fertigstellen",d->descr);
// 	formatMail("Erinnerung\n\nDie Aufgabe \n\n\t %s\n\nsoll bis %s fertiggestellt sein.\n\n\nWeitere Informationen\nInitiator:       %s\nAufgabendetails: %s\n\n\n--\nDies ist eine automatische Erinnerung der %s bei \n\t%s\n",text,r,0);
// 	sprintf(text,"Erinnerung\n\nDie Aufgabe \n\n\t %s\n\nsoll bis %s fertiggestellt sein.\n\n\nWeitere Informationen\nInitiator:       %s\nAufgabendetails: %s\n\n\n--\nDies ist eine automatische Erinnerung der %s bei \n\t%s\n",
// 		todo->descr,date2Str(todo->startDate,1800,start),userList[todo->init].full,
// 		todo->descr+todo->tlen,progName,company);
      }
      else
       {
	if (send2Extern)
	 {
	  formatMail(mailMaskErinExternSubj,subj,r,send2Extern);
	  formatMail(mailMaskErinExternText,text,r,send2Extern);
	 }
	else
	 {
	  formatMail(mailMaskErinInternSubj,subj,r,send2Extern);
	  formatMail(mailMaskErinInternText,text,r,send2Extern);
	 }
// 	sprintf(subj,"Terminerinnerung: %s",d->descr);
// 	formatMail("Erinnerung\n\nFolgender Termin wurde von %E angesetzt:\n\n\t%T\n\nBeginn: %B\nEnde  : %S\nOrt   : %R\n\n\nweitere Infromationen\n\n%D\n\n\n--\nDies ist eine automatische Erinnerung der %M bei \n\t%A\n",text,r,send2Extern);
// 	sprintf(text,"Erinnerung\n\nFolgender Termin wurde von %s angesetzt:\n\n\t%s\n\nBeginn: %s\nEnde  : %s\nOrt   : %s\n\n\nweitere Details\n\n%s\n\n\n--\nDies ist eine automatische Erinnerung der %s bei \n\t%s\n",
// 		userList[d->init.id].full,d->descr,
// 		date2Str(r->ct.ctrl->startDate,r->ct.ctrl->startTime,start),date2Str(r->ct.ctrl->stopDate,r->ct.ctrl->stopTime,stop),
// 		roomList[d->room].name,d->descr+d->tlen,progName,company);
       }
     }
     break;
    case REMINDER_MAHNUNG: 
     {
	formatMail(mailMaskMahnToDoSubj,subj,r,0);
	formatMail(mailMaskMahnToDoText,text,r,0);
//       sprintf(subj,"Mahnung: Aufgabe '%s' ist versptet",todo->descr);
//       formatMail("MAHNUNG\n\nDie Fertigstellung der Aufgabe \n\n\t %T\n\nist berfllig\nDer Zeiltermin war %S\n\n\nWeitere Informationen\nInitiator:       %I\nAufgabendetails: %D\n\n\n--\nDies ist eine automatische Mahnung der %M bei \n\t%A\n",text,r,0);
//       sprintf(text,"MAHNUNG\n\nDie Fertigstellung der Aufgabe \n\n\t %s\n\nist berfllig\nDer Zeiltermin war %s\n\n\nWeitere Informationen\nInitiator:       %s\nAufgabendetails: %s\n\n\n--\nDies ist eine automatische Mahnung der %s bei \n\t%s\n",
// 	      todo->descr,date2Str(todo->startDate,1800,start),userList[todo->init].full,
// 	      todo->descr+todo->tlen,progName,company);
     }
     break;
    }

   if(smtp[0] == '\0')
    sprintf(cmd,"echo '%s' |mail -s \"%s\" %s",text,subj,mail);
   else
    {
     sprintf(cmd,"%s %s %s  %s \"%s\" \"%s\"",mail2smtp,smtp,mail,replyAddress,subj,text);
    }
   system(cmd);
   printf("\t\t Reminder sent to %s\n---------------------------------------\n\n\n",mail);
   if(fprl!=NULL)
    {
     time_t tim;
     tim=time(NULL);
     
     if(uid>=ADDRESOFFSET && uid<=MAX_ID)
      fprintf(fprl,"%s: Reminder send for %d\'%s' send to address %d\n",strChop(ctime(&tim)),d->id,d->descr,uid-ADDRESOFFSET);
     else
      fprintf(fprl,"%s: Reminder send for %d\'%s' send to %d/%s\n",strChop(ctime(&tim)),d->id,d->descr,uid,userList[uid].name);
    }
  }
 if(verbose)
  printf("everything send\n");
 return(true);
}
int sendReminderByDialog(Reminder *r,int uid)
{
 return(true);
}
int sendReminderBySignal(Reminder *r,int uid)
{
 return(true);
}


#ifdef V038
int ignoreReminder(int did,int uid)
{
 int i;

 if(uid>userAnz)
  return(false);

 for(i=0;i<userList[uid].dmodiAnz; i++)
  if(userList[uid].dmodi[i].did == did)
   return(userList[uid].dmodi[i].noReminder);
    
 return(false);
}
#endif



// Format anweisungen:
// %E Einladene(r)  (bei todo = %I)
// %I Initiator
// %A Absender (=company)
// %M Progname
// %B Anfang des Termin  (nur bei Date)
// %S Ende der Termine  oder Zeiltermin (todo)
// %R Raum (nur bei Date)
// %T Termin-/Aufgabenberschrift
// %D Termin-/Aufgabendetails
// %l ld oder laden, in Abhngigkeit der Zahl der einladenen
// %H Datum von Heute
// %% = %
char * formatMail(char *mask,char *text,Reminder *r,int ext)
{
 char *lstr,eList[4096],txt[128],tmp[128];
 int eanz;
 char *t,*s;
 int j;
 Date *d;
 TodoItem *todo;
 
 d=(Date *) r->date;
 todo= (TodoItem * ) r->date;

 if ( (r->typ & REMINDER_FOR_TODO) ==0) 
  {
   sprintf(eList,"%s",userList[d->init.id].full);
   eanz=1;
   for(j=0;j<d->partAnz; j++)
    if(d->part[j].typ=='E')
     {
      if(d->part[j].id<GROUPOFFSET)
       sprintf(txt,", %s",userList[d->part[j].id].full);
      else if(d->part[j].id<ROOMOFFSET && !ext)
       sprintf(txt,", Gruppe %s",groupList[d->part[j].id-GROUPOFFSET].name);
      strcat(eList,txt);
      eanz++;
     }
   if(eanz >1)
    lstr="laden";
   else
    lstr="ld";
  }
 else
  {
   eanz=0;
   strcpy(eList,"");
   lstr="";
  }

 t=text;
 s=mask;
 while ( *s != '\0')
  {
   if( *s != '%' )
    {
     *t=*s;
    }
   else
    {
     s++;
     *t='\0';
     if( (r->typ & REMINDER_FOR_TODO) >0)
      {
       switch (*s)
	{
	case 'E' :
	case 'I' :strcat(text,userList[todo->init].full); break;
	case 'A' :strcat(text,company); break;
	case 'M' :strcat(text,progName); break;
	case 'T' :strcat(text,todo->descr); break;
	case 'D' :strcat(text,todo->descr+todo->tlen); break;
	case 'S' :strcat(text,date2Str(todo->startDate  ,tmp)); break;
	case 'H' :strcat(text,date2Str(today  ,tmp)); break;
	case '%' :strcat(text,"%"); break;
	}
      }
     else
      {
       switch (*s)
	{
	case 'E' :strcat(text,eList); break;
	case 'I' :strcat(text,userList[d->init.id].full); break;
	case 'A' :strcat(text,company); break;
	case 'M' :strcat(text,progName); break;
	case 'R' :strcat(text,roomList[d->room].name); break;
	case 'T' :strcat(text,d->descr); break;
	case 'D' :strcat(text,d->descr+d->tlen); break;
	case 'l' :strcat(text,lstr); break;
	case 'B' :strcat(text,date2Str(r->ct.ctrl->startDate,r->ct.ctrl->startTime,tmp)); break;
	case 'S' :strcat(text,date2Str(r->ct.ctrl->stopDate ,r->ct.ctrl->stopTime ,tmp)); break;
	case 'H' :strcat(text,date2Str(today  ,tmp)); break;
	case '%' :strcat(text,"%"); break;
	}
      }
     while(*t != '\0')
      t++;
     t--;
    }
   t++;
   s++;
  }
 printf("Formated Mail Text:\n'%s'\n",text);
}
