#define V036
#define V037
#define V0372
#define V038

#include "perm.h"
#include "address.h"


#define PARTANZ_IN_DATE 512
#define REMINDERS_IN_DATE 512

#define DATE_STAT_UKN2 0
#define DATE_STAT_UKN  1
#define DATE_STAT_ZUSAGE 2
#define DATE_STAT_ABSAGE 3
#define DATE_STAT_UNSICHER 4
#define DATE_STAT_VERSCHIEBUNG 5
#define DATE_STAT_IGNORIEREN  6

#define GROUPOFFSET 10000000
#define ROOMOFFSET 30000000
#define ADDRESOFFSET 40000000
#define MAX_ID       79999999
#define REMIND_ALL_USER 80000000
#define REMIND_ALL_INTERN 80000001
#define REMIND_ALL_EXTERN 80000002


#define DATEBLOCKSIZE 1024

#define DATE_FLAG_PRIVAT 0x0001
#define DATE_FLAG_GROUPINTERN 0x0002
#define DATE_FLAG_NOTIME 0x0004
#define DATE_FLAG_NONBLOCK 0x0008

#define DATE_FLAG_PRIVAT_SHIFT 0
#define DATE_FLAG_GROUPINTERN_SHIFT 1
#define DATE_FLAG_NOTIME_SHIFT 2

#define UID_TYP_INIT  'I'
#define UID_TYP_EINL  'E'
#define UID_TYP_TEILN 'T'
#define UID_TYP_EXT   'A'
#define UID_TYP_INFO  'i'

#define UID_FLAG_DELETED 0x4000
#define UID_LOCAL_FLAG_MASK 0xF000
#define UID_NONLOCAL_FLAG_MASK 0x0FFF

#define GROUP_MEMBER 0
#define GROUP_ADMIN 1

#define REMINDER_WAITING 0
#define REMINDER_DONE 1

#define REMINDER_BY_EMAIL  1
#define REMINDER_BY_DIALOG 2
#define REMINDER_BY_SIGNAL 4
#define REMINDER_DEST_MASK 7

#define REMINDER_FOR_TODO  0x1000

#define REMINDER_EINLADUNG  0x0100
#define REMINDER_ERINNERUNG 0x0200
#define REMINDER_MAHNUNG    0x0400
#define REMINDER_SHIFT      0x0800
#define REMINDER_TYPE_MASK  0x0F00

#define NO_REPEAT    0
#define REPEAT_TAGL  1
#define REPEAT_WOCHE 2
#define REPEAT_MONAT 3
#define REPEAT_JEDEN 4
#define REPEAT_ALLE  5
#define REPEAT_WTAGL 6

#define REPEAT_UNIT_STUND 0
#define REPEAT_UNIT_TAG   1
#define REPEAT_UNIT_WOCHE 2
#define REPEAT_UNIT_MONAT 3
#define REPEAT_UNIT_JAHR  4

typedef struct
{
 int id;         // ID des Users
 int status;     // Status desUsers (UKN, OK, NO OPEN)
 int flags;      //
 int perm;       // Rechte des Users
 int typ;        // Typ des Users (Injit, Einl, Teiln, Ext, Info)
} UserInDate;

// Structure die zur Verwaltung der Reminder beim recreate gefllt wird.
typedef struct
{
 int tim;
 int startDate;
 int startTime;
 int stopDate;
 int stopTime;
 int lastSendTim;
}ReminderControl;

typedef union
{
 ReminderControl *ctrl;
 int tim;
} ReminderCtrlUnion;

typedef struct
{
 int id;         // Addressat des Reminders
 int offset;     // Zeitversatz des Reminders 
 int offset2;    // Zeitversatz des Reminders in der nchst kleineren Einheit (nur bei unit =h oder d)
 char unit;      // Einheit des Zeitversatz (m= Minute, h=Stunde, d=Tag)
#ifdef V0372
 ReminderCtrlUnion ct;
#else
#ifdef V036
 ReminderControl *ctrl;
#else
 int tim;        // aus Date und tOffset zusammengesetzte Sekundenuhr (wird von recreateReminder erzeugt)
#endif
#endif
 int typ;       // Art des Reminders 
 int status;     // status= REMINDER_DONE, oder REMINDER_WAITING;
 void *date;     // Rckkopplung zum Date oder TODO
}Reminder;

typedef struct
{
 Reminder **list;
 int anz;
 int max;
 int blocks;
} ReminderList;




#include "todo.h"



typedef struct
{
 int  did;                  // ID des Dates das geshiftet wird.
 int  refDate,refTime;      // Zeit  zu der der Termin eigentlich angesetzt war.
 char partStatus[PARTANZ_IN_DATE];      // Stati der Teilnehmer bei dieser Instanz eines Wiederholungstermins
 int  deleted;              // Wenn true: Termin findet nicht statt.
 int  room;                 // Termin ist in diesen Raum verlegt (-1 = nicht verlegt)
 int  startDate,startTime;  // neuer Termin
 int  stopDate, stopTime;
 char addDetails [128];     // zustzliche Details
 Reminder reminder;
 char reserved [64];
} DateShift;


typedef struct 
{
 UserInDate init;
 UserInDate part[PARTANZ_IN_DATE];
 int partAnz;
 Reminder reminder[REMINDERS_IN_DATE];
 int remAnz;
 int room;
 int group;
 int flags;
 int id;
 int startDate;
 int stopDate;
 int startTime;
 int stopTime;
 char descr[1024];
 int tlen;
#ifdef V037
 char comm[4000];
 int reserverd [20];
 int dateShiftAnz;
 int dateShiftMax;
 int dateShiftPtr;
 DateShift **shifts;
#else
 char comm[4096];
#endif
 int repeatTyp;          // Typ siehe #define REPAET_????
 int repeatCount;        // Zahl der Wiederholung , 0= unbegrnzt
 int priority;           // Prioritt des Termins
 int repeatIntervall;    // Bei REPEAT_ALLE lnge des Intervall in Einheiten 'repeatUnit'
 int repeatUnit;         // Bei REPEAT_ALLE Einheit von repaet.interval
 int deleted;
} Date;


#ifdef V038
typedef struct
{
 int did;
 int ignored;
 int noReminder;
 int reserved[32];
}UserDateModification;
#endif

typedef struct
{
 int startDate;
 int startTime;
 int stopDate;
 int stopTime;
 int count;
 int startwDay;
 Date *d;
} CalendarItem;

typedef struct
{
 int id;
 int anz;
 int max;
 Date **list;
} Calendar;

typedef struct
{
 int perm;
 int id;
}UserGroupPerm;

typedef struct
{
 int beep;
 char *cmd;
}ReminderSignal;


typedef struct
{
 int id;
 char name[16];
 char full[73];
 char pwd[17];
 int groups[100];
 int ganz;
 UserGroupPerm gPerm[100];
 int gpanz;
 int calPerm;      // Rechte dritter am eigenen Kalender
 char defPermStr [64];
 char mail[4][128];
 char smtp[4][128];
 Calendar cal;
 TodoList todo;
 ProjectList proj;
 Date *editDate;
 ReminderSignal sig;
 int lastAction;
 char calFormat[16];
#ifdef V038
 UserDateModification *dmodi;
 int dmodiAnz;
 int dmodiMax;
 int dmodiDirty;
#endif
 int displayIgnore;
 int displayInfo;
 int displayToolTips;
} User;

typedef struct
{
 int id;
 char name[32];
 int anz;
 int membr[2048];
 int mstat[2048];
 int adminPerm;
 int membrPerm;
 int otherPerm;
 Calendar cal;
 TodoList todo;
 ProjectList proj;
} Group;

typedef struct
{
 int id;
 char name[64];
 char descr[188];
 int calPerm;
 Calendar cal;
} Room;



#ifdef ___MAIN
#define __EXTERN
#else
#define __EXTERN extern
#endif

__EXTERN char *dataDir;
__EXTERN User *userList;
__EXTERN Group *groupList;
__EXTERN Room *roomList;
__EXTERN int userAnz,groupAnz,roomAnz;

__EXTERN Date **dateList;
__EXTERN int dateAnz,dateBlocks,dateMax,maxDid;

__EXTERN DateShift **dateShiftList;
__EXTERN int dateShiftAnz,dateShiftMax;

__EXTERN int defGroupAdminPerm,defGroupMembrPerm,defGroupOtherPerm,defUserCalPerm,defRoomCalPerm;


__EXTERN ReminderList reminderList;
__EXTERN int nextReminder,lastReminderListCreation;


__EXTERN char progName[64],company[128];

__EXTERN int lastDateChange;

__EXTERN int today;
__EXTERN int verbose;
__EXTERN int noReminder;
__EXTERN char *serverBinPath;
__EXTERN char *mail2smtp;

__EXTERN char *mailMaskEinlExternText,*mailMaskEinlExternSubj;
__EXTERN char *mailMaskEinlInternText,*mailMaskEinlInternSubj;
__EXTERN char *mailMaskErinExternText,*mailMaskErinExternSubj;
__EXTERN char *mailMaskErinInternText,*mailMaskErinInternSubj;
__EXTERN char *mailMaskErinToDoText,  *mailMaskErinToDoSubj;
__EXTERN char *mailMaskMahnToDoText,  *mailMaskMahnToDoSubj;

__EXTERN char **holidays;
__EXTERN int holidayLines;

__EXTERN char replyAddress[256];

void readLists();
char *skip2nonWS(char *t);
char *skip2WS(char *t);
int gname2gid(char *name);
int uname2uid(char *name);
int rname2rid(char *name);
void initDateList();
int addDate(char *ds);
void writeDates();
int  readDates();
int checkPermission(Date *d,int mode ,int id);
int getPermission(Date *d, int uid,int cid);
void exportDate(Date *d,char *file);
void extendCalList(Calendar *cal);
void sendUserCal(int socket, int uid, int cid, int startDay, int stopDay,int igno,int ignoInfo);
void sendGroupCal(int socket, int uid, int cid, int startDay, int stopDay,int igno,int withUserDates,int ignoInfo);
void sendRoomCal(int socket, int uid, int cid, int startDay, int stopDay,int igno,int ignoInfo);
void getUserCal(char *str,int socket);
int send2Client(int socket,char *msg);
int split(char *txt,char **tp ,int max);
int getUserPrefs (char *str,int socket);
int saveUserPrefs (char *str,int socket);
int getLists (int socket);
int getUserList (int socket);
int getGroupList (int socket);
int getRoomList (int socket);
int getFullUserName (int socket,char *s);
int getGroupsOfUser (int socket,char *s);
int getUsersOfGroup (int socket,char *s);
int deleteDate(int socket,char *t);
int sendDate(int socket, char *t);
int getBlockedTimes(int socket, char *t);
int modifyDate(int socket,char *ds);
int aquireDate(int socket, char *ds);
int cancelEditDate (int socket,char *ds);
int sendBriefDate(int socket, char *t);
void clearLists ();
void clearDateList ();
void addComm(int socket, char *t);
void getComm (int socket, char *t);
int perm2val(char *p);
char * perm2str(int v, char *p);
UserInDate * findUserInDate(Date *d,int uid);
int readUserPrefs(int uid);
int dateIs2Privat2Me(Date *d, int uid);
char * trimRight (char *t);
char * strTrim (char *t);
int nextDateAfterNow(CalendarItem *ci,Date *d);
int getGroupMembersList (int socket);
char * strChop(char *t);


int shiftDate(int socket, char * str);
int changeDateStatus4User(int socket, char * str);
int suspendDate(int socket, char * str);
int getShiftDateInfo(int socket, char *str);
void initDateUserModification(User *usr);
void extendDateUserModification(User *usr);
int suspendReminder(int socket,char *str);
int ignoreDate(int socket,char *str);



//REminder
void initReminderList();
void clearReminderList ();
int addReminder2Date ( Date *d, char *t);
int addReminder2Date ( Date *d, Reminder *r);
int addReminder2Todo ( TodoItem *todo, char *t);
int addReminder2Todo ( TodoItem *todo, Reminder *r);
int recreateReminderList();
int updateReminderList ();
int check4Reminder();
char *date2Str(int datum, int tim,char *t);
char *date2Str(int datum, char *t);
int calcDate (int *datum, int *tim, int offset, int offset2 , int unit);
int getWeekDayInMonth(int *weekCount, int *wday,int datum);
int getCountedWeekDayDatum(int weekCount, int wday, int datum);
char *reminder2Str4Date(Reminder *r,char *t);
char *reminder2Str4Todo(Reminder *r,char *t);
int reminderIsInList(Reminder *r, Reminder *list, int anz);

int str2Reminder(Reminder *r,char *t,Date *d);
int str2Reminder(Reminder *r,char *t,TodoItem *todo);
int recalcReminder(Date *d);
int resetReminderStates(Date *d);
int weekDayByDate(int datum);

char *replaceBraces(char *t);
char *text2Pwd(char *t,char *salt);
